fil = new Array();
fil["0"]= "common-topics/c_common_DocConv_001.html@@@Documentation conventions@@@Learn about documentation conventions regarding syntax, notes, and code\nexamples...";
fil["1"]= "common-topics/c_common_DocConv_002.html@@@Syntax diagrams@@@A syntax diagram describes the context-free, abstract grammar of a product\nfunction...";
fil["2"]= "common-topics/c_common_DocConv_003.html@@@Notes, tips, and warnings@@@A documentation call-out (Important, Note, Tip, or Warning) is used to highlight content\naside from the main text...";
fil["3"]= "common-topics/c_common_DocConv_004.html@@@Code examples@@@Code examples contain code that can be copied as-is...";
fil["4"]= "common-topics/c_fjs_tm_notices.html@@@Copyrights and Trademarks@@@The Copyright and trademark page is shared amongst all Four Js documentation. Appearance\nin this page does not guarantee a mention within the current document...";
fil["5"]= "genero-tutorial-topics/c_fgl_TutChap01_001.html@@@Tutorial Chapter 1: Overview@@@This chapter provides an overview of the Tutorial and a description\nof the database schema and sample data used for the example programs...";
fil["6"]= "genero-tutorial-topics/c_fgl_TutChap01_002.html@@@Overview@@@Especially well-suited for large-scale, database-intensive business applications, Genero\nBusiness Development Language (BDL) is a reliable, easy-to-learn high-level programming\nlanguage...";
fil["7"]= "genero-tutorial-topics/c_fgl_TutChap01_003.html@@@The BDL Language@@@Genero Business Development Language (BDL) is a program language designed to write an interactive database application, as a set of programs that handle the interaction between a user and a database...";
fil["8"]= "genero-tutorial-topics/c_fgl_TutChap01_004.html@@@The BDL Tutorial@@@The chapters in this tutorial describe the basic functionality of Genero BDL...";
fil["9"]= "genero-tutorial-topics/c_fgl_TutChap01_005.html@@@The Example Database (custdemo)@@@The following SQL statements create the tables for the custdemo database...";
fil["10"]= "genero-tutorial-topics/c_fgl_TutChap01_006.html@@@The Sample Data@@@The custdemo database contains the following sample data...";
fil["11"]= "genero-tutorial-topics/c_fgl_TutChap02_001.html@@@Tutorial Chapter 2: Using BDL@@@The topics in this chapter illustrate the structure of a BDL\nprogram and some of the BDL statements that perform some common tasks - display a text message to\nthe screen, connect to a database and retrieve data, define variables, and pass variables between\nfunctions...";
fil["12"]= "genero-tutorial-topics/c_fgl_TutChap02_002.html@@@A simple BDL program@@@This simple example displays a text message to the screen, illustrating the structure of a BDL program...";
fil["13"]= "genero-tutorial-topics/c_fgl_TutChap02_004.html@@@Compiling and Executing the Program@@@BDL programs are made up of a single module, or modules, containing the program\nfunctions. You can compile and execute programs in Genero Studio or use command line tools if you\nprefer...";
fil["14"]= "genero-tutorial-topics/c_fgl_TutChap02_005.html@@@Debugging a BDL Program@@@You can use the Genero graphical debugger or the command line debugger to search for\nprogramming errors...";
fil["15"]= "genero-tutorial-topics/c_fgl_TutChap02_006.html@@@The &quot;Connect to database&quot; Program@@@This program illustrates connecting to a database and retrieving data, defining variables, and passing variables between functions...";
fil["16"]= "genero-tutorial-topics/c_fgl_TutChap02_012.html@@@Example: connectdb.4gl@@@This program connects to the custdemo database, selects the store name from the customer table and displays it to the user...";
fil["17"]= "genero-tutorial-topics/c_fgl_TutChap03_001.html@@@Tutorial Chapter 3: Displaying Data (Windows/Forms)@@@This chapter illustrates opening a window that contains a form to\ndisplay information to the user. An SQL statement is used to retrieve the data from a database\ntable. A form specification file is defined to display the values retrieved. The actions that are\navailable to the user are defined in the source code, tied to buttons that display on the\nform...";
fil["18"]= "genero-tutorial-topics/c_fgl_TutChap03_002.html@@@Application Overview@@@This example program opens a window containing a form to display information to the user...";
fil["19"]= "genero-tutorial-topics/c_fgl_TutChap03_003.html@@@The .4gl File - Opening Windows and Forms@@@A program creates a window with the OPEN WINDOW instruction,\n                        and destroys a window with the CLOSE WINDOW instruction...";
fil["20"]= "genero-tutorial-topics/c_fgl_TutChap03_004.html@@@The .4gl File - Interacting with the User@@@Your form can display options to the user using action views - buttons, dropdown menus\n    (topmenus), toolbars, and other items on the window...";
fil["21"]= "genero-tutorial-topics/c_fgl_TutChap03_005.html@@@The .4gl File - Retrieving and Displaying Data@@@The example demonstrates how to define a record so you can treat variables as a group.\n      Static SQL instructions retrieve rows from the database which are displayed to the form using the DISPLAY BY NAME statement...";
fil["22"]= "genero-tutorial-topics/c_fgl_TutChap03_006.html@@@Example: dispcust.4gl (function query_cust)@@@This function retrieves a row from the customer table and displays it in a form...";
fil["23"]= "genero-tutorial-topics/c_fgl_TutChap03_007.html@@@The Form Specification File@@@You can specify the layout of a form in a form specification file, which is compiled separately from your program. The form specification file defines the initial settings for the form, which can be changed programmatically at runtime...";
fil["24"]= "genero-tutorial-topics/c_fgl_TutChap03_008.html@@@Example: Form Specification File custform.per@@@This form specification file is used with the dispcust.4gl program to display program variables to the user. This form uses a layout with a simple GRID to define the display area...";
fil["25"]= "genero-tutorial-topics/c_fgl_TutChap03_009.html@@@Compiling the Program and Form@@@When this form is compiled (translated) using the Compile menu option in the Project view or the fglform tool, an XML file is generated that has a file extension of .42f. The runtime system uses this file along with your programs to define the Abstract User Interface...";
fil["26"]= "genero-tutorial-topics/c_fgl_TutChap04_001.html@@@Tutorial Chapter 4: Query by Example@@@The program in this chapter allows the user to search a database by entering criteria in a form. The search criteria is used to build an SQL SELECT statement to retrieve the desired database rows. A cursor is defined in the program, to allow the user to scroll back and forth between the rows of the result set.\n      Testing the success of the SQL statements and handling errors is illustrated...";
fil["27"]= "genero-tutorial-topics/c_fgl_TutChap04_002.html@@@Implementing Query-by-Example@@@This program implements query-by-example, using the CONSTRUCT statement to allow the user to enter search criteria in a form. The criteria is used to build an SQL SELECT statement which will retrieve rows from the customer database table...";
fil["28"]= "genero-tutorial-topics/c_fgl_TutChap04_004.html@@@Using CONSTRUCT and STRING variables@@@The CONSTRUCT statement temporarily binds the specified form fields to database columns. It allows you to identify database columns for which the user can enter search criteria...";
fil["29"]= "genero-tutorial-topics/c_fgl_TutChap04_005.html@@@Preparing the SQL Statement@@@The STRING created in the query-by-example is not valid for execution. The PREPARE instruction sends the text of the string to the database server for parsing, validation, and to generate the execution plan...";
fil["30"]= "genero-tutorial-topics/c_fgl_TutChap04_006.html@@@Allowing the User to Cancel the Query Operation@@@The query-by-example application demonstrates methods used to allow users to cancel an interactive dialog statement using predefined actions and conditional logic...";
fil["31"]= "genero-tutorial-topics/c_fgl_TutChap04_007.html@@@Predefined Actions (accept/cancel)@@@The language predefines some actions and associated names for common operations, such as accept or cancel, used during interactive dialogs such as CONSTRUCT...";
fil["32"]= "genero-tutorial-topics/c_fgl_TutChap04_008.html@@@DEFER INTERRUPT and the INT_FLAG@@@If the user selects Cancel during the\nCONSTRUCT, the built-in global integer variable INT_FLAG is\nautomatically set to TRUE...";
fil["33"]= "genero-tutorial-topics/c_fgl_TutChap04_009.html@@@Conditional Logic@@@Once the CONSTRUCT statement is completed, you must test whether the INT_FLAG was set to TRUE (whether the user canceled the dialog). Genero BDL provides the conditional logic statements IF or CASE to test a set of conditions...";
fil["34"]= "genero-tutorial-topics/c_fgl_TutChap04_012.html@@@The Query program@@@The Query program consists of two modules. The custmain.4gl module must be linked with the custquery.4gl module in order for the program to be run...";
fil["35"]= "genero-tutorial-topics/c_fgl_TutChap04_016.html@@@Retrieving data from the Database@@@When an SQL SELECT statement in your application will retrieve more than one row, a cursor must be used to pass the selected data to the program one row at a time...";
fil["36"]= "genero-tutorial-topics/c_fgl_TutChap04_017.html@@@Using Cursors@@@The cursor is a data structure that represents a specific location within the active set of rows that the SELECT statement retrieved...";
fil["37"]= "genero-tutorial-topics/c_fgl_TutChap04_018.html@@@The SQLCA.SQLCODE@@@The SQLCA name stands for &quot;SQL Communication Area&quot;. The SQLCA variable is a predefined record containing information on the execution of an SQL statement...";
fil["38"]= "genero-tutorial-topics/c_fgl_TutChap04_019.html@@@Example custquery.4gl (function cust_select)@@@This function is called by the function query_cust, if the row count returned by the function get_cust_cnt indicates that the criteria previously entered by the user and stored in the variable where_clause would produce an SQL SELECT result set...";
fil["39"]= "genero-tutorial-topics/c_fgl_TutChap04_020.html@@@Example: custquery.4gl (function fetch_cust)@@@This function is designed so that it can be reused each time a row is to be fetched from the customer database table; a variable is passed to indicate whether the cursor should move forward one row or backward one row...";
fil["40"]= "genero-tutorial-topics/c_fgl_TutChap04_021.html@@@Example: custquery.4gl (function fetch_rel_cust)@@@This function is called by the MENU options next and previous in the custmain.4gl module...";
fil["41"]= "genero-tutorial-topics/c_fgl_TutChap04_022.html@@@Example: custquery.4gl (function display_cust)@@@This function displays the contents of the mr_custrec record in the form. It is called by the functions query_cust and fetch_rel_cust...";
fil["42"]= "genero-tutorial-topics/c_fgl_TutChap04_023.html@@@Compiling and Linking the Program@@@The two example modules must be compiled and then linked into a single program.  You can select the Build option in the Genero Studio Project view to perform these tasks or use command line tools...";
fil["43"]= "genero-tutorial-topics/c_fgl_TutChap04_024.html@@@Modifying the Program to Handle Errors@@@Topics in this section describe methods to detect and handle errors encountered during program execution...";
fil["44"]= "genero-tutorial-topics/c_fgl_TutChap04_025.html@@@The WHENEVER ERROR statement@@@Since program statements that access the database may be expected to fail occasionally (the row is locked, etc.) the WHENEVER ERROR statement can be used to handle this type of error...";
fil["45"]= "genero-tutorial-topics/c_fgl_TutChap04_026.html@@@Negative SQLCA.SQLCODE@@@The database server returns an execution code whenever an SQL statement is executed,\n        available in SQLCA.SQLCODE. If the code is a negative number, an SQL error has occurred...";
fil["46"]= "genero-tutorial-topics/c_fgl_TutChap04_027.html@@@SQLERRMESSAGE@@@If an SQL error occurs, the SQLERRMESSAGE operator returns the error message associated with the error code. This is a character string that can be displayed to the user with the ERROR instruction...";
fil["47"]= "genero-tutorial-topics/c_fgl_TutChap04_028.html@@@Close and Free the Cursor@@@Closing and freeing the cursor when you no longer need it is good practice,\n        especially if the modules are part of a larger program...";
fil["48"]= "genero-tutorial-topics/c_fgl_TutChap04_029.html@@@Error if Cursor is not Open@@@In the example program in this chapter, if the user selects the Next or Previous action from the MENU before he has queried, the program returns an error (&quot;Program stopped at line .... Fetch attempted on unopened cursor&quot;)...";
fil["49"]= "genero-tutorial-topics/c_fgl_TutChap05_001.html@@@Tutorial Chapter 5: Enhancing the Form@@@Program forms can be displayed in a variety of ways. This chapter\nillustrates adding a toolbar or a topmenu (pull-down menu) by modifying the form specification file,\nchanging the window&apos;s appearance, and disabling/enabling actions. The example programs in this\nchapter use some of the action defaults defined by Genero BDL to standardize the presentation of\ncommon actions to the user...";
fil["50"]= "genero-tutorial-topics/c_fgl_TutChap05_002.html@@@Adding a Toolbar@@@A toolbar presents buttons on the form associated with actions defined by the current interactive BDL instruction in your program...";
fil["51"]= "genero-tutorial-topics/c_fgl_TutChap05_005.html@@@Adding a Topmenu@@@A topmenu presents a pull-down menu on a form, composed of actions defined by the current interactive BDL instruction in your program...";
fil["52"]= "genero-tutorial-topics/c_fgl_TutChap05_008.html@@@Adding a COMBOBOX form item@@@A combobox defines a dropdown box of values, allowing the user to select a value for the underlying formfield...";
fil["53"]= "genero-tutorial-topics/c_fgl_TutChap05_009.html@@@Changing the Window Appearance@@@Genero provides attributes that can be used to customize the appearance of windows,\nforms, and form objects in your application. In addition, you can create Presentation Styles to\nstandardize the appearance of window and form objects across applications...";
fil["54"]= "genero-tutorial-topics/c_fgl_TutChap05_010.html@@@Example: (in custform.per)@@@This example shows how to define a combobox in a text-based form specification file (custform.per)...";
fil["55"]= "genero-tutorial-topics/c_fgl_TutChap05_011.html@@@Example: (in custmain.4gl)@@@This example shows how to use the built-in class method ui.Interface.setImage to change the icon for the application windows...";
fil["56"]= "genero-tutorial-topics/c_fgl_TutChap05_012.html@@@Managing Actions@@@In the example in the previous lesson, if the user clicks the Next or Previous buttons on the application form without first querying successfully, a message displays and no action is taken. You can disable and enable the actions instead, providing visual cues to the user when the actions are not available...";
fil["57"]= "genero-tutorial-topics/c_fgl_TutChap05_017.html@@@Example: (custmain.4gl)@@@Calls to the setActionActive method from the ui.Dialog class have been added to custmain.4gl to disable and enable menu actions appropriately to give the user visual cues. An additional ON ACTION statement exits the menu if the user selects the\n                        &quot;X&quot; in the upper right corner of the interface...";
fil["58"]= "genero-tutorial-topics/c_fgl_TutChap05_018.html@@@Action Defaults@@@The Genero BDL runtime system includes an XML file,\n               default.4ad, in the lib subdirectory of the installation directory FGLDIR, that defines presentation attributes for some commonly used actions...";
fil["59"]= "genero-tutorial-topics/c_fgl_TutChap05_019.html@@@MENU/Action Defaults Interaction@@@Attributes defined in the form specification file override attributes defined in the\n            .4ad file...";
fil["60"]= "genero-tutorial-topics/c_fgl_TutChap05_020.html@@@Images@@@The image files specified in these definitions are among the files provided with the Genero Desktop Client, in the pics subdirectory...";
fil["61"]= "genero-tutorial-topics/c_fgl_TutChap06_001.html@@@Tutorial Chapter 6: Add, Update and Delete@@@This program allows the user to insert/update/delete rows in the\ncustomer database table. Embedded SQL statements\n(UPDATE/INSERT/DELETE) are used to update the\ntable, based on the values stored in the program record. SQL transactions, concurrency, and\nconsistency are discussed. A dialog window is displayed to prompt the user to verify the deletion of\na row...";
fil["62"]= "genero-tutorial-topics/c_fgl_TutChap06_002.html@@@Entering data on a form: INPUT statement@@@The INPUT statement allows the user to enter or change the values in a program record, which can then be used as the data for new rows in a database table, or to update existing rows...";
fil["63"]= "genero-tutorial-topics/c_fgl_TutChap06_005.html@@@Updating Database Tables@@@The values of the program variables that have been input through the form can be used in SQL statements that update tables in a database...";
fil["64"]= "genero-tutorial-topics/c_fgl_TutChap06_006.html@@@SQL transactions@@@The embedded SQL statements INSERT, UPDATE, and DELETE can be used to make changes to the contents of a database table...";
fil["65"]= "genero-tutorial-topics/c_fgl_TutChap06_007.html@@@Concurrency and Consistency@@@While your program is modifying data, another program may also be reading or modifying\nthe same data. To prevent errors, database servers use a system of locks...";
fil["66"]= "genero-tutorial-topics/c_fgl_TutChap06_008.html@@@Adding a new row@@@The INPUT statement provides control blocks to allow your program to initialize field contents and validate user input when adding a new row...";
fil["67"]= "genero-tutorial-topics/c_fgl_TutChap06_009.html@@@INPUT Statement Control blocks@@@Control blocks BEFORE FIELD and ON CHANGE are called automatically during an INPUT as the user moves the cursor through the fields of a form...";
fil["68"]= "genero-tutorial-topics/c_fgl_TutChap06_010.html@@@Example: add a new row to the customer table@@@New functions are added to the custmain.4gl and custquery.4gl modules to allow users to add rows to the customer table...";
fil["69"]= "genero-tutorial-topics/c_fgl_TutChap06_011.html@@@Module custmain.4gl@@@The MENU statement in the module custmain.4gl is modified to call functions for adding, updating, and deleting the rows in the customer table...";
fil["70"]= "genero-tutorial-topics/c_fgl_TutChap06_012.html@@@Module custquery.4gl (function inpupd_cust)@@@A new function, inpupd_cust, is added to the custquery.4gl module, allowing the user to insert values for a new customer row into the form...";
fil["71"]= "genero-tutorial-topics/c_fgl_TutChap06_013.html@@@Module custquery.4gl (function insert_cust)@@@A new function, insert_cust, in the custquery.4gl module, contains the logic to add the new row to the customer table...";
fil["72"]= "genero-tutorial-topics/c_fgl_TutChap06_014.html@@@Updating an existing Row@@@Updating an existing row in a database table provides more opportunity for concurrency and consistency errors than inserting a new row.  Use techniques shown in this section to help minimize the errors...";
fil["73"]= "genero-tutorial-topics/c_fgl_TutChap06_015.html@@@Using a work record@@@A work record and a local record, both identical to the program record, are defined to allow the program to compare the values...";
fil["74"]= "genero-tutorial-topics/c_fgl_TutChap06_016.html@@@SELECT ... FOR UPDATE@@@To explicitly lock a database row prior to updating, a SELECT...FOR UPDATE statement may be used to instruct the database server to lock the row that was selected.  SELECT ... FOR UPDATE cannot be used outside of an explicit transaction. The locks are held until the end of the transaction...";
fil["75"]= "genero-tutorial-topics/c_fgl_TutChap06_017.html@@@SCROLL CURSOR WITH HOLD@@@Like many programs that perform database maintenance, the Query program uses a SCROLL CURSOR to move through an SQL result set, updating or deleting the rows as needed. BDL cursors are automatically closed by the database interface when a COMMIT WORK or ROLLBACK WORK statement is performed.\n        To allow the user to continue to scroll through the result set, the SCROLL CURSOR can be declared WITH HOLD, keeping it open across multiple transactions...";
fil["76"]= "genero-tutorial-topics/c_fgl_TutChap06_018.html@@@Example: Updating a Row in the customer table@@@Functions are modified in the custquery.4gl module to allow users to update existing rows in the customer table...";
fil["77"]= "genero-tutorial-topics/c_fgl_TutChap06_019.html@@@Module custquery.4gl@@@The module has been modified to define a work_custrec record that can be used as working storage when a row is being updated...";
fil["78"]= "genero-tutorial-topics/c_fgl_TutChap06_020.html@@@Deleting a Row@@@The SQL DELETE statement can be used to delete rows from the database table. The primary key of the row to be deleted can be obtained from the values in the program record...";
fil["79"]= "genero-tutorial-topics/c_fgl_TutChap06_021.html@@@Using a dialog Menu to prompt for validation@@@The MENU statement has an optional STYLE attribute that can be set to &apos;dialog&apos;, automatically opening a temporary modal window. You can also define a message and icon with the COMMENT and IMAGE attributes. This provides a simple way to prompt the user to confirm some action or operation that has been selected...";
fil["80"]= "genero-tutorial-topics/c_fgl_TutChap06_022.html@@@Example: Deleting a Row@@@Function delete_check is added to the custquery.4gl module to check whether a store has any orders in the database before allowing the user to delete the store from the customer table. If there are no existing orders, a dialog MENU is used to prompt the user for confirmation...";
fil["81"]= "genero-tutorial-topics/c_fgl_TutChap07_001.html@@@Tutorial Chapter 7: Array Display@@@The example in this chapter displays multiple customer records at once. The disparray program defines a program array to hold the records, and displays the records in a form containing a table and a screen array. The example program is then modified to dynamically fill the array as needed.\n      This program illustrates a library function - the example is written so it can be used in multiple programs, maximizing code reuse...";
fil["82"]= "genero-tutorial-topics/c_fgl_TutChap07_002.html@@@Defining the Form@@@The scrolling list of customer records demonstrated in this chapter requires a form specification file containing a screen array of screen records...";
fil["83"]= "genero-tutorial-topics/c_fgl_TutChap07_007.html@@@Creating the Function@@@The main module, cust_stub.4gl calls the library function display_custarr, which uses a cursor with a FOREACH statement to load rows from the customer table into a program array.  The DISPLAY ARRAY statement displays the records in the program array to the screen array defined in the form specification file...";
fil["84"]= "genero-tutorial-topics/c_fgl_TutChap07_010.html@@@The DISPLAY ARRAY Statement@@@The DISPLAY ARRAY statement lets the user view the contents of an array of records, scrolling through the display...";
fil["85"]= "genero-tutorial-topics/c_fgl_TutChap07_014.html@@@Compiling and using a Library@@@Since this is a function that could be used by other programs that reference the customer table, the function will be compiled into a library. The library can then be linked into any program, and the function called...";
fil["86"]= "genero-tutorial-topics/c_fgl_TutChap07_016.html@@@Paged Mode of DISPLAY ARRAY@@@The previous example retrieves all the rows from the customer table into the program array prior to the data being displayed by the DISPLAY ARRAY statement.\n        Using this full list mode, you must copy into the array all the data you want to display.\n        Using the DISPLAY ARRAY statement in paged mode allows you to provide data rows dynamically during the dialog, using a dynamic array to hold one page of data...";
fil["87"]= "genero-tutorial-topics/c_fgl_TutChap07_017.html@@@What is the Paged mode?@@@The paged mode allows a program to display a very large number of rows without copying all the rows into the program array at once.  The program array holds only the current visible page...";
fil["88"]= "genero-tutorial-topics/c_fgl_TutChap07_018.html@@@AFTER DISPLAY block@@@The AFTER DISPLAY block is executed one time, after the user has accepted or canceled the dialog, but before executing the next statement in the program...";
fil["89"]= "genero-tutorial-topics/c_fgl_TutChap07_019.html@@@Example of paged mode@@@In the first example, the records in the customer table are loaded into the program array and the user uses the form to scroll through the program array. In this example, the user is actually scrolling through the result set created by a SCROLL CURSOR. This SCROLL CURSOR retrieves only the store number,\n                        and another SQL SELECT statement is used to retrieve the remainder of the row as needed...";
fil["90"]= "genero-tutorial-topics/c_fgl_TutChap08_001.html@@@Tutorial Chapter 8: Array Input@@@The program in this chapter allows the user to view and change a\nlist of records displayed on a form. As each record in the program array is added, updated, or\ndeleted, the program logic makes corresponding changes in the rows of the corresponding database\ntable...";
fil["91"]= "genero-tutorial-topics/c_fgl_TutChap09_001.html@@@Tutorial Chapter 9: Reports@@@This program generates a simple report of the data in the customer database table. The two parts of a report, the report driver logic and the report definition are illustrated. A technique to allow a user to interrupt a long-running report is shown...";
fil["92"]= "genero-tutorial-topics/c_fgl_TutChap09_002.html@@@BDL Reports@@@Genero BDL reports are easy to design and generate. The output from a report can be formatted so that the eye of the reader can easily pick out the important data...";
fil["93"]= "genero-tutorial-topics/c_fgl_TutChap09_003.html@@@The Report Driver@@@The part of a program that generates the rows of report data (also known as input records) is called the report driver. The primary concern of the row-producing logic is the selection of rows of data...";
fil["94"]= "genero-tutorial-topics/c_fgl_TutChap09_004.html@@@The Report Definition@@@The report definition uses a REPORT program block to format the input records...";
fil["95"]= "genero-tutorial-topics/c_fgl_TutChap09_009.html@@@Two-pass reports@@@A two-pass report is one that creates temporary tables, therefore there must be an active connection to the database...";
fil["96"]= "genero-tutorial-topics/c_fgl_TutChap09_011.html@@@Example: Customer Report@@@This example demonstrates a simple report driver and definition.  The report driver extracts rows from the customer database table and passes them to the report definition to be formatted...";
fil["97"]= "genero-tutorial-topics/c_fgl_TutChap09_012.html@@@The Report Driver@@@The Report Driver for this example, custreports.4gl defines a cursor to retrieve customer table rows sorted by state,\n        then city. The START REPORT statement initializes the report and provides destination and page setup information to the Report Definition...";
fil["98"]= "genero-tutorial-topics/c_fgl_TutChap09_013.html@@@The Report Definition@@@The Report Definition uses the REPORT program block to format the input records from the Report Driver...";
fil["99"]= "genero-tutorial-topics/c_fgl_TutChap09_014.html@@@Interrupting a Report@@@When a program performs a long process like a loop, a report, or a database query,\n        the lack of user interaction statements within the process can prevent the user from interrupting it. In this program, the preceding example is modified to display a form containing start, exit, and interrupt buttons, as well as a progress bar showing how close the report is to completion...";
fil["100"]= "genero-tutorial-topics/c_fgl_TutChap09_018.html@@@Example: Interruption Handling@@@The progressbar application in chapter 9 show the changes needed to facilitate interruption handling.  A form specification file, reportprog.per contains form fields for a PROGRESSBAR and interrupt action view.  The Report Driver, custreports.4gl, has been modified to handle interrupts...";
fil["101"]= "genero-tutorial-topics/c_fgl_TutChap09_019.html@@@The Form Specification File@@@A form containing a progress bar is defined in the form specification file reportprog.per...";
fil["102"]= "genero-tutorial-topics/c_fgl_TutChap09_020.html@@@Modifications to custreports.4gl@@@The MAIN program block has been modified to open a window containing the form with a PROGRESSBAR and a MENU, to allow the user to start the report and to exit. A new function, cust_report, is added for interruption handling. The report definition, the cust_list REPORT block,\n        remains the same as in the previous example...";
fil["103"]= "genero-tutorial-topics/c_fgl_TutChap09_021.html@@@The cust_report function@@@This new function contains the report driver, together with the logic to determine whether the user has attempted to interrupt the report...";
fil["104"]= "genero-tutorial-topics/c_fgl_TutChap10_001.html@@@Tutorial Chapter 10: Localization@@@Localization support and localized strings allow you to\ninternationalize your application using different languages, and to customize it for specific\nindustry markets in your user population. This chapter illustrates the use of localized strings in\nyour programs...";
fil["105"]= "genero-tutorial-topics/c_fgl_TutChap10_002.html@@@Localization Support@@@Localization Support is a feature of the language that allows you to write application supporting multibyte character sets as well as date, numeric and currency formatting in accordance with a locale...";
fil["106"]= "genero-tutorial-topics/c_fgl_TutChap10_003.html@@@Localized Strings@@@Localized Strings allow you to internationalize your application using different languages, and to customize it for specific industry markets in your user population. Any string that is used in your Genero BDL program, such as messages to be displayed or the text on a form, can be defined as a Localized String. At runtime, the Localized String is replaced with text stored in a String File...";
fil["107"]= "genero-tutorial-topics/c_fgl_TutChap10_005.html@@@Strings in Sources@@@A Localized String begins with a percent sign (%), followed by the name of the string identifying the replacement text to be loaded from the compiled String File. Since the name is a STRING, you can use any characters in the name, including blanks...";
fil["108"]= "genero-tutorial-topics/c_fgl_TutChap10_006.html@@@Extracting Strings@@@You can generate a Source String File by extracting all of the Localized Strings from your program module or form specification file, using the -m option of fglcomp or fglform...";
fil["109"]= "genero-tutorial-topics/c_fgl_TutChap10_007.html@@@Compiling String Source Files (fglmkstr)@@@String Source Files must be compiled to binary files in order to be used at runtime...";
fil["110"]= "genero-tutorial-topics/c_fgl_TutChap10_008.html@@@Deploying String Files@@@The Compiled String Files must be deployed on the production sites. The file extension is .42s. By default, the runtime system searches for a\n            .42s file with the same name prefix as the current .42r program. You can specify a list of string files with entries in the fglprofile configuration file...";
fil["111"]= "genero-tutorial-topics/c_fgl_TutChap10_009.html@@@Example: Localization@@@The progstrings program demonstrates localized strings in a form and program module...";
fil["112"]= "genero-tutorial-topics/c_fgl_TutChap10_010.html@@@form.per - the form specification file@@@The form specification file uses the LABEL form item type to display the text associated with the form fields containing data from the customer database table. LABEL item types contain read-only values.  The TEXT of the LABEL form items contain Localized Strings.  The COMMENT attribute of an EDIT item is also a Localized String...";
fil["113"]= "genero-tutorial-topics/c_fgl_TutChap10_012.html@@@prog.4gl - the program module@@@The program module opens the form containing Localized Strings.  The program module also contains Localized Strings for messages to be displayed...";
fil["114"]= "genero-tutorial-topics/c_fgl_TutChap10_014.html@@@Compiling the program@@@Compile the program and string file using Genero Studio or command line tools...";
fil["115"]= "genero-tutorial-topics/c_fgl_TutChap11_001.html@@@Tutorial Chapter 11: Master/Detail@@@The form used by the program in this chapter contains fields from\nboth the orders and items tables in the custdemo\ndatabase, illustrating a master-detail relationship. Since there are multiple items associated with\na single order, the rows from the items table are displayed in a table on the form.\nThis chapter focuses on the master/detail form and the unique features of the corresponding\nprogram...";
fil["116"]= "genero-tutorial-topics/c_fgl_TutChap11_002.html@@@The Master-Detail sample@@@The example discussed in this chapter is designed for the input of order information\n        (headers and order lines), illustrating a typical master-detail relationship. The form used by the example contains fields from both the orders and items tables in the custdemo database...";
fil["117"]= "genero-tutorial-topics/c_fgl_TutChap11_004.html@@@The Makefile@@@The BDL modules and forms used by the application in this chapter can be compiled and linked in Genero Studio using the Application-level Execute or Build options.  If you prefer command line tools you can compile and link using a Makefile. This file is interpreted by the make utility, which is a well-known tool to build large programs based on multiple sources and forms...";
fil["118"]= "genero-tutorial-topics/c_fgl_TutChap11_005.html@@@The Customer List Module@@@The custlist.4gl module defines a &apos;zoom&apos; module, to let the user select a customer from a list. The module could be reused for any application that requires the user to select a customer from a list...";
fil["119"]= "genero-tutorial-topics/c_fgl_TutChap11_006.html@@@The Stock List Module@@@The stocklist.4gl module defines a &apos;zoom&apos; module, to let the\nuser select a stock item from a list. This module uses the stocklist.per form\nand is typical list handling using the DISPLAY ARRAY statement, as discussed in Chapter\n07...";
fil["120"]= "genero-tutorial-topics/c_fgl_TutChap11_007.html@@@The Master-Detail Form Specification File@@@The form specification file orderform.per defines a form for the orders program, and displays fields containing the values of a single order from the orders table. The name of the store is retrieved from the customer table, using the column store_num, and displayed. A screen array displays the associated rows from the items table...";
fil["121"]= "genero-tutorial-topics/c_fgl_TutChap11_008.html@@@The Orders Program orders.4gl@@@Much of the functionality is identical to that in earlier Tutorial examples. The query/add/delete/update of the orders table would be the same as the examples in Chapter 4 and Chapter 6. Only append and query are included in this program, for simplicity. The add/delete/update of the items table is similar to that in Chapter 8. The complete orders program is outlined, with examples of any new functionality...";
fil["122"]= "genero-tutorial-topics/c_fgl_TutChap11_009.html@@@The MAIN program block@@@The MAIN program block contains the menu for the orders program...";
fil["123"]= "genero-tutorial-topics/c_fgl_TutChap11_010.html@@@Function setup_actions@@@This function is used by the main menu to enable or disable actions based on the context...";
fil["124"]= "genero-tutorial-topics/c_fgl_TutChap11_011.html@@@Function order_new@@@This function handles the input of an order record...";
fil["125"]= "genero-tutorial-topics/c_fgl_TutChap11_012.html@@@Function order_insert@@@This function inserts a new record in the orders database table...";
fil["126"]= "genero-tutorial-topics/c_fgl_TutChap11_013.html@@@Function order_query@@@This function allows the user to enter query criteria for the orders table. It calls the function order_select to retrieve the rows from the database table...";
fil["127"]= "genero-tutorial-topics/c_fgl_TutChap11_014.html@@@Function order_fetch@@@This function retrieves the row from the orders table, and is designed to be reused each time a row is needed. If the retrieval of the row from the orders table is successful, the function items_fetch is called to retrieve the corresponding rows from the items table...";
fil["128"]= "genero-tutorial-topics/c_fgl_TutChap11_015.html@@@Function order_select@@@This function creates the SQL statement for the query and the corresponding cursor to retrieve the rows from the orders table. It calls the function fetch_order...";
fil["129"]= "genero-tutorial-topics/c_fgl_TutChap11_016.html@@@Function order_fetch_rel@@@This function calls the function order_fetch to retrieve the rows in the database; the parameter p_fetch_flag indicates the direction for the cursor movement. If there are no more records to be retrieved, a message is displayed to the user...";
fil["130"]= "genero-tutorial-topics/c_fgl_TutChap11_017.html@@@Function order_total@@@This function calculates the total price for all of the items contained on a single order...";
fil["131"]= "genero-tutorial-topics/c_fgl_TutChap11_018.html@@@Function order_close@@@This function closes the cursor used to select orders from the database...";
fil["132"]= "genero-tutorial-topics/c_fgl_TutChap11_019.html@@@Function items_fetch@@@This function retrieves the rows from the items table that match the value of order_num in the order currently displayed on the form. The description and unit values are retrieved from the stock table, using the column stock_num. The value for line_total is calculated and retrieved. After displaying the items on the form, the function order_total is called to calculate the total price of all the items for the current order...";
fil["133"]= "genero-tutorial-topics/c_fgl_TutChap11_020.html@@@Function items_show@@@This function displays the line items for the order in the screen array and returns immediately...";
fil["134"]= "genero-tutorial-topics/c_fgl_TutChap11_021.html@@@Function items_inpupd@@@This function contains the program logic to allow the user to input a new row in the arr_items array, or to change or delete an existing row...";
fil["135"]= "genero-tutorial-topics/c_fgl_TutChap11_022.html@@@Function items_line_total@@@This function calculates the value of line_total for any new rows that are inserted into the arr_items array...";
fil["136"]= "genero-tutorial-topics/c_fgl_TutChap11_023.html@@@Function item_insert@@@This function inserts a new row into the items database table using the values input in the current array record on the form...";
fil["137"]= "genero-tutorial-topics/c_fgl_TutChap11_024.html@@@Function item_update@@@This function updates a row in the items database table using the changes made to the current array record in the form...";
fil["138"]= "genero-tutorial-topics/c_fgl_TutChap11_025.html@@@Function item_delete@@@This function deletes a row from the items database table, based on the values in the current record of the items array...";
fil["139"]= "genero-tutorial-topics/c_fgl_TutChap11_026.html@@@Function get_stock_info@@@This function verifies that the stock number entered for a new row in the arr_items array exists in the stock table. It retrieves the description, unit of measure, and the correct price based on whether promotional pricing is in effect for the order...";
fil["140"]= "genero-tutorial-topics/c_fgl_TutChap12_001.html@@@Tutorial Chapter 12: Changing the User Interface Dynamically@@@This chapter focuses on using the classes and methods in the\nui package of built-in classes to modify the user interface at runtime. Among the\ntechniques illustrated are hiding or disabling form items; changing the text, style or image\nassociated with a form item; loading a combobox from a database table; and adding toolbars and\ntopmenus dynamically...";
fil["141"]= "genero-tutorial-topics/c_fgl_TutChap12_002.html@@@Built-in Classes@@@Included in the predefined functions that are built into Genero are special groups\n        (classes) of functions (methods) that act upon the objects that are created when your program is running. Each class of methods interacts with a specific program object, allowing you to change the appearance or behavior of the objects. Because these methods act upon program objects, the syntax is somewhat different from that of functions...";
fil["142"]= "genero-tutorial-topics/c_fgl_TutChap12_003.html@@@Working with Forms@@@The Form class provides some methods that allow you to change the appearance or behavior of items on a form...";
fil["143"]= "genero-tutorial-topics/c_fgl_TutChap12_004.html@@@Hiding Form Items@@@You can use Form class methods to change the value of the hidden property of form items, hiding parts of the form from the user...";
fil["144"]= "genero-tutorial-topics/c_fgl_TutChap12_005.html@@@Adding toolbars, topmenus, and action defaults@@@The Form class provides methods that apply topmenus, toolbars, and action defaults to a form, to assist you in standardizing forms...";
fil["145"]= "genero-tutorial-topics/c_fgl_TutChap12_006.html@@@Specifying a Function to Initialize all Forms@@@To assist in standardizing forms, you can create an initializer function in your program that will be called automatically whenever any form is opened. A reference to the form object is passed by the runtime system to the function...";
fil["146"]= "genero-tutorial-topics/c_fgl_TutChap12_007.html@@@Loading a ComboBox List@@@A ComboBox presents a list of values in a dropdown box on a form. The values are for the underlying formfield. For example, the following form specification file contains a ComboBox that represents...";
fil["147"]= "genero-tutorial-topics/c_fgl_TutChap12_008.html@@@Using the Dialog class in Interactive Statements@@@The Dialog class provides methods that can only be called from within an interactive instruction (dialog) such as MENU,\n            INPUT, INPUT ARRAY, DISPLAY ARRAY and CONSTRUCT...";
fil["148"]= "genero-tutorial-topics/c_fgl_TutChap12_009.html@@@Hiding Default Action Views@@@To hide default action views (the buttons that appear on the form when there is no specific action view for an action), use the following Dialog class method...";
fil["149"]= "genero-tutorial-topics/c_fgl_TutChap12_010.html@@@Enabling and Disabling Fields@@@This method in the Dialog class allows you to disable fields on a form\nduring the interactive statement; the field is still visible, but the user cannot edit the value...";
fil["150"]= "genero-tutorial-topics/c_fgl_TutChap12_011.html@@@Using the Interface Class@@@Methods in the Interface class allow you interact with the user\ninterface, as shown in the examples...";
fil["151"]= "genero-tutorial-topics/c_fgl_TutChap13_001.html@@@Tutorial Chapter 13: Master/Detail using Multiple Dialogs@@@This chapter shows how to implement order and items input in a\nunique DIALOG statement. In chapter 11 the order input is detached from the items\ninput. The code example in chapter 13 makes both order and item input fields active at the same\ntime, which is more natural in GUI applications...";
fil["152"]= "genero-tutorial-topics/c_fgl_TutChap13_002.html@@@The Master-Detail sample@@@The example discussed in this chapter is designed for the input of order information (headers and order lines), illustrating a typical master-detail relationship. The form used by the example contains...";
fil["153"]= "genero-tutorial-topics/c_fgl_TutChap13_003.html@@@The Customer List Form@@@The Customer List form displays when the user clicks the button next to the store number\nfield (the buttonEdit widget). The custlist.per form defines a typical &apos;zoom&apos;\nform with a filter field and record list where the user can pick an element to be used in a field of\nthe main form. Using this form, the user can scroll through the list to pick a store, or can enter\nquery criteria to filter the list prior to picking. The fields that make up the columns of the table\nthat display the list are defined as FORMONLY fields. When TYPE is\nnot defined, the default data type for FORMONLY fields is\nCHAR...";
fil["154"]= "genero-tutorial-topics/c_fgl_TutChap13_004.html@@@The Customer List Module@@@The custlist.4gl module defines a &apos;zoom&apos; module, to let the user select a customer from a list. The module could be reused for any application that requires the user to select a customer from a list...";
fil["155"]= "genero-tutorial-topics/c_fgl_TutChap13_005.html@@@The Orders Form@@@The form specification file orderform.per defines a form for the orders program, and displays fields containing the values of a single order from the orders table. The name of the store is retrieved from the customer table, using the column store_num, and displayed...";
fil["156"]= "genero-tutorial-topics/c_fgl_TutChap13_006.html@@@The Orders Program orders.4gl@@@The orders.4gl module implements the main form controller. Most of the functionality has been described in previous chapters. In this section we will only focus on the DIALOG instruction programming. The program implements a DIALOG instruction, including an INPUT BY NAME sub-dialog for the order fields input, and an INPUT ARRAY sub-dialog for the items input. Unlike traditional 4GL programs using singular dialogs, you typically start the program in the multiple dialog instruction, eliminating the global MENU instruction...";
fil["157"]= "genero-tutorial-topics/c_fgl_TutChap13_007.html@@@Module variables of orders.4gl@@@The module variables are used by the orders.4gl module...";
fil["158"]= "genero-tutorial-topics/c_fgl_TutChap13_008.html@@@Function orditems_dialog@@@This is the most important function of the program. It implements the multiple dialog instruction to control order and items input simultaneously...";
fil["159"]= "genero-tutorial-topics/c_fgl_TutChap13_009.html@@@Function order_update@@@This function validates that the values in the order_rec program record are correct, and then executes an SQL statement to update the row in the orders database table...";
fil["160"]= "genero-tutorial-topics/c_fgl_TutChap13_010.html@@@Function order_new@@@This function inserts a new row in the database table orders, using the values from the order_rec program record...";
fil["161"]= "genero-tutorial-topics/c_fgl_TutChap13_011.html@@@Function order_validate@@@This function validates the entries in the fields of the orders screen record...";
fil["162"]= "genero-tutorial-topics/c_fgl_TutChap13_012.html@@@Function order_query@@@This function allows the user to search for a specific order by entering criteria into the form (Query by Example). This CONSTRUCT statement is not a sub-dialog of a DIALOG statement. It is a stand-alone statement called by the action find, triggered when the user selects the corresponding menu item or toolbar icon on the form orderform...";
fil["163"]= "genero-tutorial-topics/c_fgl_TutIndex_001.html@@@How to write an application in Genero BDL@@@This tutorial is designed for developers new to Genero and the Genero Business\nDevelopment Language (BDL)...";
fil["164"]= "genero-tutorial-topics/c_fgl_TutIndex_002.html@@@Tutorial Chapters@@@Each chapter illustrates Genero Business Development Language (BDL) concepts with\nprogram examples...";
fil["165"]= "genero-tutorial-topics/c_fgl_TutIndex_003.html@@@Testing the Example Programs@@@The program examples used in this tutorial are packaged with Genero Studio. To run the\nprograms you will need a complete install of the Genero product suite...";
fil["166"]= "genero-tutorial-topics/t_fgl_TutChap04_003.html@@@Steps for implementing Query-by-Example@@@This topic describes the steps involved to implement query-by-example using the CONSTRUCT statement...";
fil["167"]= "genero-tutorial-topics/t_fgl_TutChap10_004.html@@@Programming Steps@@@These steps describe how to use Localized Strings in your sources...";
var doStem = false;searchLoaded = true;