var keywords=[{w:"Doc",p:["p0"]},{w:"conventions",p:["p0","p1"]},{w:"Documentation",p:["p1"]},{w:"Syntax",p:["p2"]},{w:"diagrams",p:["p2"]},{w:"Notes,",p:["p3"]},{w:"tips,",p:["p3"]},{w:"and",p:["p3","p5","p14","p20","p22","p26","p29","p33","p43","p48","p62","p66","p86","p142","p147"]},{w:"warnings",p:["p3"]},{w:"Code",p:["p4"]},{w:"examples",p:["p4"]},{w:"Copyrights",p:["p5"]},{w:"Trademarks",p:["p5"]},{w:"Tutorial",p:["p6","p9","p12","p18","p27","p50","p62","p82","p91","p92","p102","p113","p138","p149","p157"]},{w:"Chapter",p:["p6","p12","p18","p27","p50","p62","p82","p91","p92","p102","p113","p138","p149"]},{w:"1:",p:["p6"]},{w:"Overview",p:["p6","p7","p19"]},{w:"The",p:["p8","p9","p10","p11","p14","p16","p20","p21","p22","p24","p26","p30","p31","p33","p35","p36","p38","p43","p44","p45","p48","p50","p54","p69","p77","p83","p84","p85","p88","p94","p95","p101","p110","p111","p112","p114","p115","p116","p117","p118","p119","p120","p138","p145","p148","p150","p151","p158"]},{w:"BDL",p:["p8","p9","p12","p13","p15","p93","p156"]},{w:"Language",p:["p8"]},{w:"Example",p:["p10","p27","p39","p90","p158"]},{w:"Database",p:["p10","p36","p64"]},{w:"(custdemo)",p:["p10"]},{w:"Sample",p:["p11","p114"]},{w:"Data",p:["p11","p18","p22","p36","p63"]},{w:"2:",p:["p12"]},{w:"Using",p:["p12","p29","p37","p74","p80","p86","p145","p148","p149"]},{w:"A",p:["p13","p15","p51","p52","p53","p63","p67","p69","p74","p77","p79","p80","p81","p86","p98","p143","p144"]},{w:"simple",p:["p13"]},{w:"program",p:["p13","p14","p15","p16","p26","p35","p43","p44","p111","p112","p119","p120"]},{w:"Compiling",p:["p14","p26","p43","p86","p107","p112"]},{w:"Executing",p:["p14"]},{w:"Debugging",p:["p15"]},{w:"\"Connect",p:["p16"]},{w:"to",p:["p16","p31","p44","p69","p80","p100","p143","p156"]},{w:"database\"",p:["p16"]},{w:"Example:",p:["p17","p23","p25","p40","p41","p42","p55","p56","p58","p69","p77","p81","p97","p99","p109"]},{w:"connectdb.4gl",p:["p17"]},{w:"3:",p:["p18"]},{w:"Displaying",p:["p18","p22"]},{w:"(Windows/Forms)",p:["p18"]},{w:"Application",p:["p19","p156"]},{w:".4gl",p:["p20","p21","p22"]},{w:"File",p:["p20","p21","p22","p24","p25","p110","p118"]},{w:"-",p:["p20","p21","p22","p110","p111"]},{w:"Opening",p:["p20"]},{w:"Windows",p:["p20"]},{w:"Forms",p:["p20","p140","p143"]},{w:"Interacting",p:["p21"]},{w:"with",p:["p21","p76","p140"]},{w:"User",p:["p21","p31","p138"]},{w:"Retrieving",p:["p22","p36"]},{w:"dispcust.4gl",p:["p23"]},{w:"(function",p:["p23","p39","p40","p41","p42","p71","p72"]},{w:"query_cust)",p:["p23"]},{w:"Form",p:["p24","p25","p26","p50","p53","p83","p110","p118","p141","p150","p151"]},{w:"Specification",p:["p24","p25","p110","p118"]},{w:"custform.per",p:["p25"]},{w:"4:",p:["p27"]},{w:"Query",p:["p27","p31","p35"]},{w:"by",p:["p27"]},{w:"Implementing",p:["p28","p159"]},{w:"Query-by-Example",p:["p28","p159"]},{w:"CONSTRUCT",p:["p29"]},{w:"STRING",p:["p29","p107","p108"]},{w:"variables",p:["p29","p152"]},{w:"Preparing",p:["p30"]},{w:"SQL",p:["p30","p65"]},{w:"Statement",p:["p30","p45","p63","p68","p85"]},{w:"Allowing",p:["p31"]},{w:"Cancel",p:["p31"]},{w:"Operation",p:["p31"]},{w:"Predefined",p:["p32"]},{w:"Actions",p:["p32","p57"]},{w:"(accept/cancel)",p:["p32"]},{w:"DEFER",p:["p33"]},{w:"INTERRUPT",p:["p33"]},{w:"INT_FLAG",p:["p33"]},{w:"Conditional",p:["p34"]},{w:"Logic",p:["p34"]},{w:"from",p:["p36"]},{w:"Cursors",p:["p37"]},{w:"SQLCA.SQLCODE",p:["p38","p46"]},{w:"custquery.4gl",p:["p39","p40","p41","p42","p71","p72","p78"]},{w:"cust_select)",p:["p39"]},{w:"fetch_cust)",p:["p40"]},{w:"fetch_rel_cust)",p:["p41"]},{w:"display_cust)",p:["p42"]},{w:"Linking",p:["p43"]},{w:"Modifying",p:["p44"]},{w:"Handle",p:["p44"]},{w:"Errors",p:["p44"]},{w:"WHENEVER",p:["p45"]},{w:"ERROR",p:["p45","p49"]},{w:"Negative",p:["p46"]},{w:"SQLERRMESSAGE",p:["p47"]},{w:"Close",p:["p48"]},{w:"Free",p:["p48"]},{w:"Cursor",p:["p48","p49","p76"]},{w:"if",p:["p49"]},{w:"is",p:["p49","p88"]},{w:"not",p:["p49"]},{w:"Open",p:["p49"]},{w:"5:",p:["p50"]},{w:"Enhancing",p:["p50"]},{w:"Adding",p:["p51","p52","p53","p67","p142"]},{w:"Toolbar",p:["p51"]},{w:"Topmenu",p:["p52"]},{w:"COMBOBOX",p:["p53","p144"]},{w:"item",p:["p53"]},{w:"Changing",p:["p54","p138"]},{w:"Window",p:["p54"]},{w:"Appearance",p:["p54"]},{w:"(in",p:["p55","p56"]},{w:"custform.per)",p:["p55"]},{w:"custmain.4gl)",p:["p56"]},{w:"Managing",p:["p57"]},{w:"(custmain.4gl)",p:["p58"]},{w:"Action",p:["p59","p142","p146"]},{w:"Defaults",p:["p59","p60","p142"]},{w:"MENU/Action",p:["p60"]},{w:"Interaction",p:["p60"]},{w:"Images",p:["p61"]},{w:"6:",p:["p62"]},{w:"Add,",p:["p62"]},{w:"Update",p:["p62","p75"]},{w:"Delete",p:["p62"]},{w:"Entering",p:["p63"]},{w:"on",p:["p63"]},{w:"form:",p:["p63"]},{w:"INPUT",p:["p63","p68","p91"]},{w:"Updating",p:["p64","p73","p77"]},{w:"Tables",p:["p64"]},{w:"transactions",p:["p65"]},{w:"Concurrency",p:["p66"]},{w:"Consistency",p:["p66"]},{w:"new",p:["p67","p69"]},{w:"row",p:["p67","p69","p73","p77","p79","p81"]},{w:"Control",p:["p68"]},{w:"blocks",p:["p68"]},{w:"add",p:["p69"]},{w:"customer",p:["p69","p77","p97","p116","p150"]},{w:"table",p:["p69","p77"]},{w:"Module",p:["p70","p71","p72","p78","p111","p116","p117","p152"]},{w:"custmain.4gl",p:["p70"]},{w:"inpupd_cust)",p:["p71"]},{w:"insert_cust)",p:["p72"]},{w:"an",p:["p73","p156"]},{w:"existing",p:["p73"]},{w:"work",p:["p74"]},{w:"record",p:["p74"]},{w:"SELECT",p:["p75"]},{w:"...",p:["p75"]},{w:"FOR",p:["p75","p80","p159"]},{w:"SCROLL",p:["p76"]},{w:"HOLD",p:["p76"]},{w:"in",p:["p77","p105","p145","p156"]},{w:"Deleting",p:["p79","p81"]},{w:"dialog",p:["p80","p145"]},{w:"Menu",p:["p80"]},{w:"prompt",p:["p80"]},{w:"validation",p:["p80"]},{w:"7:",p:["p82"]},{w:"Array",p:["p82","p85","p87","p91"]},{w:"Display",p:["p82","p85","p87","p89"]},{w:"Defining",p:["p83"]},{w:"Creating",p:["p84"]},{w:"Function",p:["p84","p101","p121","p122","p123","p124","p125","p126","p127","p128","p129","p130","p131","p132","p133","p134","p135","p136","p137","p143","p153","p154","p155"]},{w:"Library",p:["p86"]},{w:"Paged",p:["p87","p88","p90"]},{w:"Mode",p:["p87","p90"]},{w:"of",p:["p87","p90","p152"]},{w:"What",p:["p88"]},{w:"mode?",p:["p88"]},{w:"AFTER",p:["p89"]},{w:"block",p:["p89","p120"]},{w:"8:",p:["p91"]},{w:"9:",p:["p92"]},{w:"Reports",p:["p92","p93","p96"]},{w:"Report",p:["p94","p95","p97","p98"]},{w:"Driver",p:["p94"]},{w:"Definition",p:["p95"]},{w:"Two-pass",p:["p96"]},{w:"Interrupting",p:["p98"]},{w:"Interruption",p:["p99"]},{w:"Handling",p:["p99"]},{w:"Modifications",p:["p100"]},{w:"custreports.4gl",p:["p100"]},{w:"cust_report",p:["p101"]},{w:"10:",p:["p102"]},{w:"Localization",p:["p102","p103","p109"]},{w:"Support",p:["p103"]},{w:"Localized",p:["p104"]},{w:"Strings",p:["p104","p105","p106"]},{w:"Sources",p:["p105"]},{w:"Extracting",p:["p106"]},{w:"Source",p:["p107"]},{w:"Files",p:["p107","p108"]},{w:"(fglmkstr)",p:["p107"]},{w:"Deploying",p:["p108"]},{w:"form.per",p:["p110"]},{w:"prog.4gl",p:["p111"]},{w:"11:",p:["p113"]},{w:"Master/Detail",p:["p113","p149"]},{w:"Master-Detail",p:["p114","p118"]},{w:"Makefile",p:["p115"]},{w:"List",p:["p116","p117","p144","p150"]},{w:"Stock",p:["p117"]},{w:"Orders",p:["p119","p151"]},{w:"orders.4gl",p:["p119","p152"]},{w:"MAIN",p:["p120"]},{w:"setup_actions",p:["p121"]},{w:"order_new",p:["p122"]},{w:"order_insert",p:["p123"]},{w:"order_query",p:["p124"]},{w:"order_fetch",p:["p125"]},{w:"order_select",p:["p126"]},{w:"order_fetch_rel",p:["p127"]},{w:"order_total",p:["p128"]},{w:"order_close",p:["p129"]},{w:"items_fetch",p:["p130"]},{w:"items_show",p:["p131"]},{w:"items_inpupd",p:["p132"]},{w:"items_line_total",p:["p133"]},{w:"item_insert",p:["p134"]},{w:"item_update",p:["p135"]},{w:"item_delete",p:["p136"]},{w:"get_stock_info",p:["p137"]},{w:"12:",p:["p138"]},{w:"Interface",p:["p138","p148"]},{w:"Dynamically",p:["p138"]},{w:"Built-in",p:["p139"]},{w:"Classes",p:["p139"]},{w:"Working",p:["p140"]},{w:"Hiding",p:["p141","p146"]},{w:"Items",p:["p141"]},{w:"toolbars,",p:["p142"]},{w:"topmenus,",p:["p142"]},{w:"Specifying",p:["p143"]},{w:"Initialize",p:["p143"]},{w:"all",p:["p143"]},{w:"Loading",p:["p144"]},{w:"class",p:["p145","p148"]},{w:"Interactive",p:["p145"]},{w:"Statements",p:["p145"]},{w:"Default",p:["p146"]},{w:"Views",p:["p146"]},{w:"Enabling",p:["p147"]},{w:"Disabling",p:["p147"]},{w:"Fields",p:["p147"]},{w:"13:",p:["p149"]},{w:"Multiple",p:["p149"]},{w:"Dialogs",p:["p149"]},{w:"orditems_dialog",p:["p153"]},{w:"order_update",p:["p154"]},{w:"order_validate",p:["p155"]},{w:"How",p:["p156"]},{w:"write",p:["p156"]},{w:"Genero",p:["p156"]},{w:"Chapters",p:["p157"]},{w:"Testing",p:["p158"]},{w:"Programs",p:["p158"]},{w:"Steps",p:["p159","p160"]},{w:"Programming",p:["p160"]}];
var ph={};
ph["p160"]=[263, 262];
ph["p50"]=[13, 14, 103, 104, 17, 55];
ph["p52"]=[105, 27, 107];
ph["p51"]=[105, 27, 106];
ph["p54"]=[110, 17, 111, 112];
ph["p53"]=[105, 27, 108, 55, 109];
ph["p56"]=[36, 113, 115];
ph["p157"]=[13, 259];
ph["p55"]=[36, 113, 114];
ph["p156"]=[256, 34, 257, 147, 41, 156, 258, 18];
ph["p58"]=[36, 117];
ph["p155"]=[167, 255];
ph["p57"]=[116, 73];
ph["p154"]=[167, 254];
ph["p59"]=[118, 119];
ph["p159"]=[262, 153, 61, 62];
ph["p158"]=[260, 17, 20, 261];
ph["p61"]=[122];
ph["p60"]=[120, 119, 121];
ph["p63"]=[127, 24, 128, 27, 129, 130, 68];
ph["p153"]=[167, 253];
ph["p62"]=[13, 14, 123, 124, 125, 7, 126];
ph["p152"]=[143, 65, 171, 209];
ph["p65"]=[67, 133];
ph["p151"]=[17, 208, 55];
ph["p64"]=[131, 21, 132];
ph["p150"]=[17, 141, 206, 55];
ph["p67"]=[105, 27, 136, 137];
ph["p146"]=[234, 245, 118, 246];
ph["p66"]=[134, 7, 135];
ph["p145"]=[26, 17, 158, 242, 156, 243, 244];
ph["p69"]=[36, 140, 27, 136, 137, 34, 17, 141, 142];
ph["p144"]=[241, 27, 108, 206];
ph["p68"]=[130, 68, 138, 139];
ph["p143"]=[238, 27, 167, 34, 239, 240, 47];
ph["p149"]=[13, 14, 250, 203, 26, 251, 252];
ph["p148"]=[26, 17, 229, 242];
ph["p147"]=[247, 7, 248, 249];
ph["p70"]=[143, 144];
ph["p72"]=[143, 83, 53, 146];
ph["p71"]=[143, 83, 53, 145];
ph["p74"]=[26, 27, 149, 150];
ph["p73"]=[131, 147, 148, 137];
ph["p76"]=[154, 98, 49, 155];
ph["p75"]=[151, 152, 153, 125];
ph["p78"]=[143, 83];
ph["p77"]=[36, 131, 27, 137, 156, 17, 141, 142];
ph["p79"]=[157, 27, 137];
ph["p81"]=[36, 157, 27, 137];
ph["p80"]=[26, 27, 158, 159, 34, 160, 153, 161];
ph["p83"]=[165, 17, 55];
ph["p82"]=[13, 14, 162, 163, 164];
ph["p85"]=[17, 164, 163, 68];
ph["p84"]=[166, 17, 167];
ph["p87"]=[169, 170, 171, 164, 163];
ph["p86"]=[30, 7, 26, 27, 168];
ph["p89"]=[174, 164, 175];
ph["p88"]=[172, 100, 17, 169, 173];
ph["p90"]=[20, 171, 169, 170];
ph["p92"]=[13, 14, 177, 178];
ph["p91"]=[13, 14, 176, 163, 130];
ph["p94"]=[17, 179, 180];
ph["p93"]=[18, 178];
ph["p96"]=[182, 178];
ph["p120"]=[17, 210, 29, 175];
ph["p95"]=[17, 179, 181];
ph["p10"]=[17, 20, 21, 22];
ph["p98"]=[183, 27, 179];
ph["p97"]=[36, 141, 179];
ph["p12"]=[13, 14, 25, 26, 18];
ph["p113"]=[13, 14, 202, 203];
ph["p11"]=[17, 23, 24];
ph["p99"]=[36, 184, 185];
ph["p112"]=[30, 17, 29];
ph["p14"]=[30, 7, 31, 17, 29];
ph["p111"]=[201, 44, 17, 29, 143];
ph["p13"]=[27, 28, 18, 29];
ph["p110"]=[200, 44, 17, 55, 56, 43];
ph["p16"]=[17, 33, 34, 35, 29];
ph["p117"]=[17, 207, 206, 143];
ph["p15"]=[32, 27, 18, 29];
ph["p116"]=[17, 141, 206, 143];
ph["p18"]=[13, 14, 38, 39, 24, 40];
ph["p115"]=[17, 205];
ph["p17"]=[36, 37];
ph["p114"]=[17, 204, 23];
ph["p19"]=[41, 16];
ph["p119"]=[17, 208, 29, 209];
ph["p118"]=[17, 204, 55, 56, 43];
ph["p21"]=[17, 42, 43, 44, 48, 49, 17, 50];
ph["p20"]=[17, 42, 43, 44, 45, 46, 7, 47];
ph["p23"]=[36, 52, 53, 54];
ph["p102"]=[13, 14, 189, 190];
ph["p22"]=[17, 42, 43, 44, 51, 7, 39, 24];
ph["p101"]=[17, 188, 167];
ph["p25"]=[36, 55, 56, 43, 57];
ph["p100"]=[186, 34, 187];
ph["p24"]=[17, 55, 56, 43];
ph["p27"]=[13, 14, 58, 59, 60, 20];
ph["p106"]=[195, 193];
ph["p26"]=[30, 17, 29, 7, 55];
ph["p105"]=[193, 156, 194];
ph["p29"]=[26, 63, 7, 64, 65];
ph["p104"]=[192, 193];
ph["p28"]=[61, 62];
ph["p103"]=[190, 191];
ph["p109"]=[36, 190];
ph["p108"]=[199, 64, 197];
ph["p107"]=[30, 64, 196, 197, 198];
ph["p0"]=[0, 1];
ph["p1"]=[2, 1];
ph["p2"]=[3, 4];
ph["p3"]=[5, 6, 7, 8];
ph["p4"]=[9, 10];
ph["p5"]=[11, 7, 12];
ph["p6"]=[13, 14, 15, 16];
ph["p7"]=[16];
ph["p8"]=[17, 18, 19];
ph["p9"]=[17, 18, 13];
ph["p30"]=[66, 17, 67, 68];
ph["p142"]=[105, 236, 237, 7, 118, 119];
ph["p141"]=[234, 55, 235];
ph["p32"]=[72, 73, 74];
ph["p140"]=[233, 49, 47];
ph["p31"]=[69, 17, 50, 34, 70, 17, 59, 71];
ph["p34"]=[78, 79];
ph["p135"]=[167, 225];
ph["p33"]=[75, 76, 7, 17, 77];
ph["p134"]=[167, 224];
ph["p36"]=[51, 24, 80, 17, 21];
ph["p133"]=[167, 223];
ph["p35"]=[17, 59, 29];
ph["p132"]=[167, 222];
ph["p38"]=[17, 82];
ph["p139"]=[231, 232];
ph["p37"]=[26, 81];
ph["p138"]=[13, 14, 228, 110, 17, 50, 229, 230];
ph["p137"]=[167, 227];
ph["p39"]=[20, 83, 53, 84];
ph["p136"]=[167, 226];
ph["p41"]=[36, 83, 53, 86];
ph["p131"]=[167, 221];
ph["p40"]=[36, 83, 53, 85];
ph["p130"]=[167, 220];
ph["p43"]=[30, 7, 88, 17, 29];
ph["p42"]=[36, 83, 53, 87];
ph["p45"]=[17, 92, 93, 68];
ph["p124"]=[167, 214];
ph["p44"]=[89, 17, 29, 34, 90, 91];
ph["p123"]=[167, 213];
ph["p47"]=[95];
ph["p122"]=[167, 212];
ph["p46"]=[94, 82];
ph["p121"]=[167, 211];
ph["p49"]=[93, 99, 98, 100, 101, 102];
ph["p128"]=[167, 218];
ph["p48"]=[96, 7, 97, 17, 98];
ph["p127"]=[167, 217];
ph["p126"]=[167, 216];
ph["p125"]=[167, 215];
ph["p129"]=[167, 219];
